"
Actalk loading file:

	Actalk-FileIn.st


Version & Date:
---------------

Actalk version 3.05 (version 3 release 05)
Jean-Pierre Briot
18 May 1994


Warning:
--------

The following temporary variable should be set
at the time of installing the Actalk system.
It must indicate the full pathname of the directory/folder
where the Actalk sources (src) are located.
(Below are my own Macintosh and Unix paths as examples)."

| path |
	"Mac Finder:"
path := 'Macintosh HD:Programmation:Smalltalk-80:Actalk:3:05:src:'.
	"Unix:"
path := '/home/camille1/briot/smalltalk/actalk/3/05/src/'.


"A few little but useful extensions."

		"Method performMessage:"
(Filename named: path , 'Object-performMessage.st') fileIn.
(Filename named: path , 'Object-basicPerformMessage.st') fileIn.
		"Generic reference to (address of) an object."
(Filename named: path , 'Object-address.st') fileIn.
		"Generic access to the inner Smalltalk-80 standard object."
(Filename named: path , 'Object-asObject.st') fileIn.
		"Generic event method for sending a message."
(Filename named: path , 'Object-eventSendto.st') fileIn.
		"(Compact) printing of a Message (useful for tracing)."
(Filename named: path , 'Message-compactPrintString.st') fileIn.
		"Generic access to the sender of a message."
(Filename named: path , 'Message-sender.st') fileIn.
		"Testing most specialized among two classes."
(Filename named: path , 'Behavior-isEqualOrSubclassOf.st') fileIn.
(Filename named: path , 'Behavior-subifUnrelated.st') fileIn.
		"Collecting methods within a category/hierarchy."
(Filename named: path , 'ClassDescription-selectors.st') fileIn.


"Actalk Kernel."

		"Trapping of messages to redefine message passing semantics:
		class TrapMessagesObject."
(Filename named: path , 'Actalk-Kernel-TrapMessages.st') fileIn.
		"Basic kernel classes: Basic1(&2)ActiveObject/Activity/Address."
(Filename named: path , 'Actalk-Kernel-Basic.st') fileIn.
		"Class MailBox."
(Filename named: path , 'Actalk-Kernel-MailBox.st') fileIn.
		"Kernel classes ActiveObject, Activity and Address."
(Filename named: path , 'Actalk-Kernel.st') fileIn.
		"Class SingleMessageActivity."
(Filename named: path , 'Actalk-Kernel-Library.st') fileIn.
		"Reply destinations: Printer and BlockContinuation."
(Filename named: path , 'Actalk-Kernel-ReplyDest.st') fileIn.
		"Join continuations."
(Filename named: path , 'Actalk-Kernel-JoinCont.st') fileIn.
		"Examples: counter, factorial, fibonacci, prime numbers."
(Filename named: path , 'Actalk-Examples.st') fileIn.
		"The bounded buffer example."
(Filename named: path , 'Actalk-Ex-BoundedBuffer.st') fileIn.

	"Compatibility with old version kernel classes Actor and ActorBehavior."
(Filename named: path , 'Actalk-Kernel-Compatibility.st') fileIn.


"Actalk Extensions."

	"Simulation of Smalltalk in Actalk."
(Filename named: path , 'Actalk-Ext-Smalltalk.st') fileIn.

	"Generic sending of message (types and modes)."
(Filename named: path , 'Actalk-Ext-GenericSend.st') fileIn.

	"Recording sender of the message."
(Filename named: path , 'Actalk-Ext-WithSender.st') fileIn.
	"Example: semaphore."
(Filename named: path , 'Actalk-Ext-WithSender-Ex.st') fileIn.

	"Classes of future objects: Future, SAFuture and MAFuture."
(Filename named: path , 'Actalk-FutureObjects.st') fileIn.

	"Implicit reply (as in standard Smalltalk)."
		"Classes ImplicitReplyObject/Activity/Address."
(Filename named: path , 'Actalk-Ext-ImplicitReply.st') fileIn.
		"Examples: factorial and fibonacci revisited."
(Filename named: path , 'Actalk-Ext-ImplicitReply-Ex.st') fileIn.	

	"Extensions to the bounded buffer example (get2, gget, concurrent representation, getRear)."
(Filename named: path , 'Actalk-Ex-BoundedBuffer-Ext.st') fileIn.

	"Activities for selective acceptance."
		"Classes EnabledSelectorsActivity and SelectiveAcceptActivity."
(Filename named: path , 'Actalk-Ext-SelectActivity.st') fileIn.	

	"Actor model of computation behavior replacement concept."
		"Class ActorObject."
(Filename named: path , 'Actalk-Ext-Actor.st') fileIn.
		"Examples: bank account; bounded buffer revisited."
(Filename named: path , 'Actalk-Ext-Actor-Examples.st') fileIn.
		"Behavior for no more message expected."
(Filename named: path , 'Actalk-Ext-Actor-Library.st') fileIn.
		"Join continuations revisited."
(Filename named: path , 'Actalk-Ext-Actor-JoinCont.st') fileIn.
		"Extensions: insensitivity, behavior replacement message,
		and enabled methods."
(Filename named: path , 'Actalk-Ext-Actor-Ext.st') fileIn.
		"Useful to avoid errors when events onto a nil behavior
		(a possible case for insensitive actors)."
(Filename named: path , 'UndefinedObject-events.st') fileIn.
		"Examples: bank account and bounded buffer revisited."
(Filename named: path , 'Actalk-Ext-Actor-Ext-Ex.st') fileIn.

	"ABCL three types of message passing."
		"Classes Abcl(1/2/3)Object/Activity/Address."
(Filename named: path , 'Actalk-Ext-Abcl.st') fileIn.
		"Examples: same fringe; fibonacci and bounded buffer revisited."
(Filename named: path , 'Actalk-Ext-Abcl-Examples.st') fileIn.
		"Tree-like operations on Arrays for the same fringe example."
(Filename named: path , 'Array-tree_operations.st') fileIn.

	"Explicit message acceptance."
		"Classes ExplicitAcceptObject/Activity."
(Filename named: path , 'Actalk-Ext-Accept.st') fileIn.
		"Examples: quicksort; bounded buffer revisited."
(Filename named: path , 'Actalk-Ext-Accept-Examples.st') fileIn.

	"Body live routine (with explicit message acceptance)."
		"Classes ObjectBodyActivity and SimulatedBodyObject."
(Filename named: path , 'Actalk-Ext-Body.st') fileIn.
		"Examples: thieves; bounded buffer revisited."
(Filename named: path , 'Actalk-Ext-Body-Examples.st') fileIn.
		"Random operations on collections for the example of thieves."
(Filename named: path , 'OrderedCollection-random.st') fileIn.

	"Pool explicit message acceptance, body, and post actions."
		"Classes PoolActor(Behavior)."
(Filename named: path , 'Actalk-Ext-Pool.st') fileIn.
		"Examples: distributed symbol table and dining philosophers."
(Filename named: path , 'Actalk-Ext-Pool-Examples.st') fileIn.


"Actalk extensions for synchronization of message acceptance."

	"Synchronization with abstract states."
(Filename named: path , 'Actalk-Synchro-AbsStates.st') fileIn.
		"Example: bounded buffer revisited."
(Filename named: path , 'Actalk-Synchro-AbsStates-Ex.st') fileIn.
		"Set-like (union and difference) operations on Arrays
		for composition of abstract states."
(Filename named: path , 'SeqColl-copyWithoutAnyOf.st') fileIn.
(Filename named: path , 'Array-set_operations.st') fileIn.

	"Synchronization with guards."
(Filename named: path , 'Actalk-Synchro-Guards.st') fileIn.
		"Examples: bounded buffer and dining philosophers revisited."
(Filename named: path , 'Actalk-Synchro-Guards-Ex.st') fileIn.

	"Synchronization with meta-level and user-events as in OCore."
		"Example: bounded buffer revisited."
(Filename named: path , 'Actalk-Synchro-OCore-Ex.st') fileIn.

	"Abstract class for concurrent active objects
	(management of multiple subprocesses)."
(Filename named: path , 'Actalk-Concurrent.st') fileIn.

	"Synchronization with suspension (monitor-like) as in ConcurrentSmalltalk-II."
(Filename named: path , 'Actalk-Synchro-Suspend.st') fileIn.
	"Example: bounded buffer revisited."
(Filename named: path , 'Actalk-Synchro-Suspend-Ex.st') fileIn.

	"Synchronization with counters."
(Filename named: path , 'Actalk-Synchro-Counters.st') fileIn.
	"Examples: readers & writers; bounded buffer revisited."
(Filename named: path , 'Actalk-Synchro-Counters-Ex.st') fileIn.

	"Synchronization with generic invocations."
(Filename named: path , 'Actalk-Synchro-Invocation.st') fileIn.
	"Synchronization examples revisited with message ordering preservation,
	 shortest job priority, and starvation avoidance."
(Filename named: path , 'Actalk-Synchro-Invocation-Ex.st') fileIn.

	"Mixed synchronization with abstract states and counters/generic invocations."
(Filename named: path , 'Actalk-Synchro-ASC.st') fileIn.
	"Example: bounded buffer revisited."
(Filename named: path , 'Actalk-Synchro-ASC-Examples.st') fileIn.


"A minimal time slicing scheduler extension."
(Filename named: path , 'ProcessorScheduler-slice.st') fileIn.
(Filename named: path , 'ProcessorScheduler_class-slc.st') fileIn.

	"Protected transcript window when using time-slicing."
(Filename named: path , 'SharedTextCollector.st') fileIn.

""!
